import { PartialSQL, Skip, SerializableParameterDynamic } from './types';
import { Sql, Row, PendingQuery, TransactionSql } from 'postgres';
interface JSToPostgresTypeMap {
    [name: string]: unknown;
}
declare type UnwrapPromiseArray<T> = T extends any[] ? {
    [k in keyof T]: T[k] extends Promise<infer R> ? R : T[k];
} : T;
declare function partial(xs: TemplateStringsArray, ...args: SerializableParameterDynamic[]): PartialSQL;
export declare type TransactionSqlWithDynamic<TTypes extends JSToPostgresTypeMap> = {
    savepoint<T>(cb: (sql: TransactionSqlWithDynamic<TTypes>) => T | Promise<T>): Promise<UnwrapPromiseArray<T>>;
    savepoint<T>(name: string, cb: (sql: TransactionSqlWithDynamic<TTypes>) => T | Promise<T>): Promise<UnwrapPromiseArray<T>>;
} & TransactionSql<TTypes> & {
    skip: Skip;
    partial: typeof partial;
} & {
    <T extends Row | Row[] = Row>(template: TemplateStringsArray, ...args: SerializableParameterDynamic[]): PendingQuery<T extends Row[] ? T : T[]>;
};
export declare type SqlWithDynamic<TTypes extends JSToPostgresTypeMap> = {
    begin<T>(cb: (sql: TransactionSqlWithDynamic<TTypes>) => T | Promise<T>): Promise<UnwrapPromiseArray<T>>;
    begin<T>(options: string, cb: (sql: TransactionSqlWithDynamic<TTypes>) => T | Promise<T>): Promise<UnwrapPromiseArray<T>>;
} & Sql<TTypes> & {
    skip: Skip;
    partial: typeof partial;
} & {
    <T extends Row | Row[] = Row>(template: TemplateStringsArray, ...args: SerializableParameterDynamic[]): PendingQuery<T extends Row[] ? T : T[]>;
};
export declare function wrap<TTypes extends JSToPostgresTypeMap>(sql: Sql<TTypes>): SqlWithDynamic<TTypes>;
export {};
